/*
 * Copyright 1993, 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */

/*******************************************************************************
	AddDemo.c

*******************************************************************************/

#include <stdio.h>
#include <Xm/Xm.h>
#include <X11/Shell.h>
#include <Xm/MenuShell.h>
#include "UxXt.h"

#include <Xm/List.h>
#include <Xm/ScrolledW.h>
#include <Xm/SeparatoG.h>
#include <Xm/Label.h>
#include <Xm/PushB.h>
#include <Xm/TextF.h>
#include <Xm/Text.h>
#include <Xm/Form.h>

/*******************************************************************************
	Includes, Defines, and Global variables from the Declarations Editor:
*******************************************************************************/

#include "exinterfmotif.h"
#include <string.h>
#include "exbookglo.h"
#include "exglobals.h"
#include "exinterf.h"

Boolean EditExeFilename;
int EditExePos;

/*******************************************************************************
	The definition of the context structure:
	If you create multiple instances of your interface, the context
	structure ensures that your callbacks use the variables for the
	correct instance.

	For each Widget in the interface, each argument to the Interface
	function, and each variable in the Instance Specific section of the
	Declarations Editor, there is an entry in the context structure.
	and a #define.  The #define makes the variable name refer to the
	corresponding entry in the context structure.
*******************************************************************************/

typedef	struct
{
	Widget	UxNameText;
	Widget	UxDoneButton;
	Widget	UxCancelButton;
	Widget	UxNextButton;
	Widget	UxCommandText;
	Widget	UxAltCommandText;
	Widget	UxHelpFileText;
	Widget	UxWSiconText;
	Widget	UxImageiconText;
	Widget	UxscrolledWindow1;
	Widget	UxExistKeywordList;
	Widget	UxNewKeywordText;
	Widget	UxscrolledWindow2;
	Widget	UxDemoKeywordList;
	Widget	UxExeFileText;
	Widget	UxscrolledWindow3;
	Widget	UxExeFileList;
	Widget	UxDeleteFileButton;
	Widget	UxDeleteKeywordButton;
	Widget	UxEditButton;
} _UxCAddDemo;

#define NameText                UxAddDemoContext->UxNameText
#define DoneButton              UxAddDemoContext->UxDoneButton
#define CancelButton            UxAddDemoContext->UxCancelButton
#define NextButton              UxAddDemoContext->UxNextButton
#define CommandText             UxAddDemoContext->UxCommandText
#define AltCommandText             UxAddDemoContext->UxAltCommandText
#define WSiconText              UxAddDemoContext->UxWSiconText
#define HelpFileText              UxAddDemoContext->UxHelpFileText
#define ImageiconText           UxAddDemoContext->UxImageiconText
#define scrolledWindow1         UxAddDemoContext->UxscrolledWindow1
#define ExistKeywordList        UxAddDemoContext->UxExistKeywordList
#define NewKeywordText          UxAddDemoContext->UxNewKeywordText
#define scrolledWindow2         UxAddDemoContext->UxscrolledWindow2
#define DemoKeywordList         UxAddDemoContext->UxDemoKeywordList
#define ExeFileText             UxAddDemoContext->UxExeFileText
#define scrolledWindow3         UxAddDemoContext->UxscrolledWindow3
#define ExeFileList             UxAddDemoContext->UxExeFileList
#define DeleteFileButton        UxAddDemoContext->UxDeleteFileButton
#define DeleteKeywordButton     UxAddDemoContext->UxDeleteKeywordButton
#define EditButton              UxAddDemoContext->UxEditButton

static _UxCAddDemo	*UxAddDemoContext;

Widget	AddDemo;

/*******************************************************************************
	Forward declarations of functions that are defined later in this file.
*******************************************************************************/

Widget	create_AddDemo();

/*******************************************************************************
	The following are callback functions.
*******************************************************************************/

static void	activateCB_DoneButton( UxWidget, UxClientData, UxCallbackArg )
	Widget		UxWidget;
	XtPointer	UxClientData, UxCallbackArg;
{
	_UxCAddDemo             *UxSaveCtx, *UxContext;

	UxSaveCtx = UxAddDemoContext;
	UxAddDemoContext = UxContext =
			(_UxCAddDemo *) UxGetContext( UxWidget );
	{
	int exefile_count;
	XmString *exefile_table;
	char *exefile_string;
	struct charlist *charptr, *newcharptr, *prevcharptr;
	Arg args[5];
	int i, n;
	char *tmpstr;

        tmpstr = XmTextFieldGetString(NameText);  /* get the name */
	strcpy (ADName.buf, tmpstr);		/* copy it into struct */
        XtFree(tmpstr);				/* free up string */
        tmpstr = XmTextGetString(CommandText);	/* get command */
	strcpy (ADCommand.buf, tmpstr);		/* copy it into struct */
        XtFree(tmpstr);				/* free string */
	ADName.bufpos    = strlen(ADName.buf);	/* give length of both strings */
	ADCommand.bufpos = strlen(ADCommand.buf);

	if (ADName.bufpos <= 0) {		/* make sure there's a name */
	  sprintf(msgstring, "\nYou must enter a Name.\n");
	  DialogType = 1;
	  popup_Message();
	}
	else if (ADCommand.bufpos <= 0) {	/* and a command */
	  sprintf(msgstring, "\nYou must enter a Command.\n");
	  DialogType = 1;
	  popup_Message();
	}
	else {
          tmpstr = XmTextGetString(AltCommandText);	/* get alternate command */
	  strcpy (ADAltCommand.buf, tmpstr);
          XtFree(tmpstr);
	  ADAltCommand.bufpos   = strlen(ADAltCommand.buf);
          tmpstr = XmTextFieldGetString(WSiconText);	/* get icon info */
	  strcpy (ADIfile.buf, tmpstr);
          XtFree(tmpstr);
	  ADIfile.bufpos   = strlen(ADIfile.buf);
          tmpstr = XmTextFieldGetString(ImageiconText); 
	  strcpy (ADIfile2.buf, tmpstr);
          XtFree(tmpstr);
	  ADIfile2.bufpos  = strlen(ADIfile2.buf);
          tmpstr = XmTextFieldGetString(HelpFileText);  /* get helpfile info */
	  strcpy (ADHfile.buf, tmpstr);
          XtFree(tmpstr);
	  ADHfile.bufpos  = strlen(ADHfile.buf);
	  GetDemoKeywords();			/* make list of keywords */

	  n = 0;
	  XtSetArg(args[n], XmNitemCount, &exefile_count); n++;
	  XtSetArg(args[n], XmNitems, &exefile_table); n++;
	  XtGetValues(ExeFileList, args, n);	/* now executable list... */
	  if (exefile_count == 0) {		/* if no executables */
	    DialogType = 5;	     	     /* tell them no files were there */
	    popup_Question();
	    UxWaitForNotify();
	    if (WantToEnterFilesFlag == False) { /* they said no, they didn't*/
	      if (EF_change) {			/* null out pointers */
	        Head_FL = NULL;
	        Tail_FL = NULL;
	      }
	      goto DONE;
	    }
	  }
	  else {
	    if (EF_change) {
	      Head_FL = NULL;
	      Tail_FL = NULL;
	      for (i=0; i<exefile_count; i++) {
	        exefile_string = extract_first_xms_segment(exefile_table[i]);
	        newcharptr = (struct charlist *)malloc(sizeof(struct charlist));
	        if (Head_FL == NULL)
		  Head_FL = newcharptr;
	        else
		  Tail_FL->next = newcharptr;
	        Tail_FL = newcharptr;
                Tail_FL->next = NULL;
	        Tail_FL->indexflag = 0;
	        Tail_FL->str = exefile_string;
	      }
	    }

DONE:	    if (EditDemoFlag == 0) {	
	      add_demo();
	    }
	    else {			/* they really added a demo */
	      savedemochanges();
	      EditDemoFlag = 0;
	    }
	    charptr = HeadChar;
	    while (charptr != NULL) {
	      prevcharptr = charptr->next;
	      if (charptr->indexflag == 0) free(charptr->str);
	      free(charptr);
	      charptr = prevcharptr;
	    }
	    HeadChar = NULL;
	    TailChar = NULL;
	    Head_FL  = NULL;
	    Tail_FL  = NULL;
	    WantToEnterFilesFlag = True;

	    XtVaSetValues( NameText, XmNvalue, "", NULL );
	    XtVaSetValues( CommandText, XmNvalue, "", NULL );
	    XtVaSetValues( AltCommandText, XmNvalue, "", NULL );
	    XtVaSetValues( WSiconText, XmNvalue, "", NULL );
	    XtVaSetValues( HelpFileText, XmNvalue, "", NULL );
	    XtVaSetValues( ImageiconText, XmNvalue, "", NULL );
	    XtVaSetValues( NewKeywordText, XmNvalue, "", NULL );
	    XtVaSetValues( ExeFileText, XmNvalue, "", NULL );
	    XmListDeselectAllItems(ExistKeywordList);
	    XmListSetPos(ExistKeywordList, 1);
	    XmListDeleteAllItems(DemoKeywordList);
	    XmListDeleteAllItems(ExeFileList);

	    ADwin = -1;
	    UxPopdownInterface(AddDemo);
	    InterfaceWinOpen-- ;
            drawscene(0);
	  }
	}
	}
	UxAddDemoContext = UxSaveCtx;
}

static void	activateCB_CancelButton( UxWidget, UxClientData, UxCallbackArg )
	Widget		UxWidget;
	XtPointer	UxClientData, UxCallbackArg;
{
	_UxCAddDemo             *UxSaveCtx, *UxContext;

	UxSaveCtx = UxAddDemoContext;
	UxAddDemoContext = UxContext =
			(_UxCAddDemo *) UxGetContext( UxWidget );
	{
	struct charlist *charptr, *prevcharptr;

	charptr = HeadChar;
	while (charptr != NULL) {
	  prevcharptr = charptr->next;
	  if (charptr->indexflag == 0) free(charptr->str);
	  free(charptr);
	  charptr = prevcharptr;
	}
	HeadChar = NULL;
	TailChar = NULL;
	Head_FL = NULL;
	Tail_FL = NULL;
	EditDemoFlag = 0;
	XtVaSetValues( NameText, XmNvalue, "", NULL );
	XtVaSetValues( CommandText, XmNvalue, "", NULL );
	XtVaSetValues( AltCommandText, XmNvalue, "", NULL );
	XtVaSetValues( WSiconText, XmNvalue, "", NULL );
	XtVaSetValues( HelpFileText, XmNvalue, "", NULL );
	XtVaSetValues( ImageiconText, XmNvalue, "", NULL );
	XtVaSetValues( NewKeywordText, XmNvalue, "", NULL );
	XtVaSetValues( ExeFileText, XmNvalue, "", NULL );
	XmListDeselectAllItems(ExistKeywordList);
	XmListSetPos(ExistKeywordList, 1);
	XmListDeleteAllItems(DemoKeywordList);
	XmListDeleteAllItems(ExeFileList);
	ADwin = -1;
	UxPopdownInterface(AddDemo);
	InterfaceWinOpen-- ;
        drawscene(0);
	}
	UxAddDemoContext = UxSaveCtx;
}

static void	activateCB_NextButton( UxWidget, UxClientData, UxCallbackArg )
	Widget		UxWidget;
	XtPointer	UxClientData, UxCallbackArg;
{
	_UxCAddDemo             *UxSaveCtx, *UxContext;

	UxSaveCtx = UxAddDemoContext;
	UxAddDemoContext = UxContext =
			(_UxCAddDemo *) UxGetContext( UxWidget );
	{
	int exefile_count;
	XmString *exefile_table;
	char *exefile_string;
	struct charlist *charptr, *newcharptr, *prevcharptr;
	Arg args[5];
	int i, n;
	char *tmpstr;

        tmpstr = XmTextFieldGetString(NameText);
	strcpy (ADName.buf, tmpstr);
        XtFree(tmpstr);
        tmpstr = XmTextGetString(CommandText);
	strcpy (ADCommand.buf, tmpstr);
        XtFree(tmpstr);
	ADName.bufpos    = strlen(ADName.buf);
	ADCommand.bufpos = strlen(ADCommand.buf);
	if (ADName.bufpos <= 0) {
	  sprintf(msgstring, "\nYou must enter a Name.\n");
	  DialogType = 1;
	  popup_Message();
	}
	else if (ADCommand.bufpos <= 0) {
	  sprintf(msgstring, "\nYou must enter a Command.\n");
	  DialogType = 1;
	  popup_Message();
	}
	else {
          tmpstr = XmTextGetString(AltCommandText);
	  strcpy (ADAltCommand.buf, tmpstr);
          XtFree(tmpstr);
	  ADAltCommand.bufpos   = strlen(ADAltCommand.buf);
          tmpstr = XmTextFieldGetString(WSiconText);
	  strcpy (ADIfile.buf, tmpstr);
          XtFree(tmpstr);
	  ADIfile.bufpos   = strlen(ADIfile.buf);
          tmpstr = XmTextFieldGetString(ImageiconText);
	  strcpy (ADIfile2.buf, tmpstr);
          XtFree(tmpstr);
	  ADIfile2.bufpos  = strlen(ADIfile2.buf);
          tmpstr = XmTextFieldGetString(HelpFileText);
	  strcpy (ADHfile.buf, tmpstr);
          XtFree(tmpstr);
	  ADHfile.bufpos  = strlen(ADHfile.buf);
	  GetDemoKeywords();

	  n = 0;
	  XtSetArg(args[n], XmNitemCount, &exefile_count); n++;
	  XtSetArg(args[n], XmNitems, &exefile_table); n++;
	  XtGetValues(ExeFileList, args, n);
/*	  printf("Num Exe Files = %d\n", exefile_count); */
	  if (exefile_count == 0) {
	    DialogType = 5;
	    popup_Question();
	    UxWaitForNotify();
	    if (WantToEnterFilesFlag == False) {
	      if (EF_change) {
	        Head_FL = NULL;
	        Tail_FL = NULL;
	      }
	      goto NEXT;
	    }
	  }
	  else {
	    if (EF_change) {
	      Head_FL = NULL;
	      Tail_FL = NULL;
/*	      printf("Exe & Data Files = \n"); */
	      for (i=0; i<exefile_count; i++) {
	        exefile_string = extract_first_xms_segment(exefile_table[i]);
/*	        printf("%d  %d  %s\n", exefile_count, i, exefile_string); */
	        newcharptr = (struct charlist *)malloc(sizeof(struct charlist) );
	        if (Head_FL == NULL)
		  Head_FL = newcharptr;
	        else
		  Tail_FL->next = newcharptr;
	        Tail_FL = newcharptr;
                Tail_FL->next = NULL;
	        Tail_FL->indexflag = 0;
	        Tail_FL->str = exefile_string;
	      }
	    }

NEXT:	    if (EditDemoFlag == 0) {
	      add_demo();
	      charptr = HeadChar;
	      while (charptr != NULL) {
	        prevcharptr = charptr->next;
	        if (charptr->indexflag == 0) free(charptr->str);
	        free(charptr);
	        charptr = prevcharptr;
	      }
	      HeadChar = NULL;
	      TailChar = NULL;
	      Head_FL = NULL;
	      Tail_FL = NULL;
	      initadwin();
	    }
	    WantToEnterFilesFlag = True;
	    XtVaSetValues( NameText, XmNvalue, "", NULL );
	    XtVaSetValues( CommandText, XmNvalue, "", NULL );
	    XtVaSetValues( AltCommandText, XmNvalue, "", NULL );
	    XtVaSetValues( WSiconText, XmNvalue, "", NULL );
	    XtVaSetValues( HelpFileText, XmNvalue, "", NULL );
	    XtVaSetValues( ImageiconText, XmNvalue, "", NULL );
	    XtVaSetValues( NewKeywordText, XmNvalue, "", NULL );
	    XtVaSetValues( ExeFileText, XmNvalue, "", NULL );
	    XmListDeselectAllItems(ExistKeywordList);
	    XmListSetPos(ExistKeywordList, 1);
	    XtVaSetValues( ExistKeywordList,
			XmNitemCount, ExistKeywordCount,
			RES_CONVERT( XmNitems, ExistKeywordString ),
			NULL );
	    XmListDeleteAllItems(DemoKeywordList);
	    XmListDeleteAllItems(ExeFileList);
	  }
	}
	}
	UxAddDemoContext = UxSaveCtx;
}

static void	browseSelectionCB_ExistKeywordList( UxWidget, UxClientData, UxCallbackArg )
	Widget		UxWidget;
	XtPointer	UxClientData, UxCallbackArg;
{
	_UxCAddDemo             *UxSaveCtx, *UxContext;

	UxSaveCtx = UxAddDemoContext;
	UxAddDemoContext = UxContext =
			(_UxCAddDemo *) UxGetContext( UxWidget );
	{
	int *pos_list;
	int pos_count;
	int i;
	XmListCallbackStruct *cbs;

	cbs = (XmListCallbackStruct *)UxCallbackArg;
	    if ( ! (XmListItemExists(DemoKeywordList, cbs->item)) ) {
	      XmListAddItem(DemoKeywordList, cbs->item, 0);
	      XmListSetBottomPos(DemoKeywordList, 0);
	      KW_change = TRUE;
	    }
	}
	UxAddDemoContext = UxSaveCtx;
}

static void	activateCB_NewKeywordText( UxWidget, UxClientData, UxCallbackArg )
	Widget		UxWidget;
	XtPointer	UxClientData, UxCallbackArg;
{
	_UxCAddDemo             *UxSaveCtx, *UxContext;

	UxSaveCtx = UxAddDemoContext;
	UxAddDemoContext = UxContext =
			(_UxCAddDemo *) UxGetContext( UxWidget );
	{
	XmString item;
	ADKey.bufpos = 0;
	bufclear(&ADKey);
	strcpy (ADKey.buf, (char *)XmTextFieldGetString(NewKeywordText));
	ADKey.bufpos = strlen(ADKey.buf);
	if (ADKey.bufpos > 0) {
	  item = (XmString)XmStringCreateLtoR(
		ADKey.buf, XmSTRING_DEFAULT_CHARSET);
	  if ( ! (XmListItemExists(DemoKeywordList,item)) ) {
	    XmListAddItem(DemoKeywordList, item, 0);
	    XmListSetBottomPos(DemoKeywordList, 0);
	    XtVaSetValues( NewKeywordText, XmNvalue, "", NULL );
	    KW_change = TRUE;
	  }
	}
	}
	UxAddDemoContext = UxSaveCtx;
}

static void	activateCB_ExeFileText( UxWidget, UxClientData, UxCallbackArg )
	Widget		UxWidget;
	XtPointer	UxClientData, UxCallbackArg;
{
	_UxCAddDemo             *UxSaveCtx, *UxContext;

	UxSaveCtx = UxAddDemoContext;
	UxAddDemoContext = UxContext =
			(_UxCAddDemo *) UxGetContext( UxWidget );
	{
	char string[255];
	XmString item;
	string[0] = '\0';
	strcat (string, (char *)XmTextFieldGetString(ExeFileText));
	item = (XmString)XmStringCreateLtoR(
	  string, XmSTRING_DEFAULT_CHARSET);
	if (strcmp(string,"") != 0) {
	  if ( ! (XmListItemExists(ExeFileList,item)) ) {
	    if (EditExeFilename) {
	      XmListDeletePos(ExeFileList, EditExePos);
	      XmListAddItem(ExeFileList, item, EditExePos);
	      XmListSetBottomPos(ExeFileList, EditExePos);
	      XtVaSetValues( ExeFileText, XmNvalue, "", NULL );
	      EditExeFilename = False;
	    }
	    else {
	      XmListAddItem(ExeFileList, item, 0);
	      XmListSetBottomPos(ExeFileList, 0);
	    }
	  }
	  EF_change = TRUE;
	}
	}
	UxAddDemoContext = UxSaveCtx;
}

static void	activateCB_DeleteFileButton( UxWidget, UxClientData, UxCallbackArg )
	Widget		UxWidget;
	XtPointer	UxClientData, UxCallbackArg;
{
	_UxCAddDemo             *UxSaveCtx, *UxContext;

	UxSaveCtx = UxAddDemoContext;
	UxAddDemoContext = UxContext =
			(_UxCAddDemo *) UxGetContext( UxWidget );
	{
	int *pos_list;
	int pos_count;
	while ( XmListGetSelectedPos(
	  (ExeFileList), &pos_list, &pos_count) ) {
	  XmListDeletePos(ExeFileList, pos_list[0]);
	  EF_change = TRUE;
	  XtFree((char *)pos_list); 
	}
	}
	UxAddDemoContext = UxSaveCtx;
}

static void	activateCB_DeleteKeywordButton( UxWidget, UxClientData, UxCallbackArg )
	Widget		UxWidget;
	XtPointer	UxClientData, UxCallbackArg;
{
	_UxCAddDemo             *UxSaveCtx, *UxContext;

	UxSaveCtx = UxAddDemoContext;
	UxAddDemoContext = UxContext =
			(_UxCAddDemo *) UxGetContext( UxWidget );
	{
	int *pos_list;
	int pos_count;
	while ( XmListGetSelectedPos(
	  (DemoKeywordList), &pos_list, &pos_count) ) {
	  XmListDeletePos(DemoKeywordList, pos_list[0]);
	  KW_change = TRUE;
	  XtFree((char *)pos_list); 
	}
	}
	UxAddDemoContext = UxSaveCtx;
}

static void	activateCB_EditButton( UxWidget, UxClientData, UxCallbackArg )
	Widget		UxWidget;
	XtPointer	UxClientData, UxCallbackArg;
{
	_UxCAddDemo             *UxSaveCtx, *UxContext;

	UxSaveCtx = UxAddDemoContext;
	UxAddDemoContext = UxContext =
			(_UxCAddDemo *) UxGetContext( UxWidget );
	{
	int *pos_list;
	int pos_count;
	int pos;
	int edit_count;
	XmString *edit_table;
	char *edit_string;
	Arg args[5];
	int n;

	if ( XmListGetSelectedPos(
	  (ExeFileList), &pos_list, &pos_count) ) {
	  if (pos_count == 1) {
	    pos = pos_list[0];
	    n = 0;
	    XtSetArg(args[n], XmNselectedItemCount, &edit_count); n++;
	    XtSetArg(args[n], XmNselectedItems, &edit_table); n++;
	    XtGetValues(ExeFileList, args, n);
	    edit_string = extract_first_xms_segment(edit_table[0]);
	    XtVaSetValues( ExeFileText, XmNvalue, edit_string, NULL );
	    XtVaSetValues( ExeFileText, XmNcursorPosition, strlen(edit_string), NULL );
	    /* printf("%d  %s\n", edit_count, edit_string); */
	    EditExeFilename = True;
	    EditExePos = pos;
	  }
	  XtFree((char *)pos_list);
	}
	}
	UxAddDemoContext = UxSaveCtx;
}

/*******************************************************************************
	The 'build_' function creates all the Widgets and X widgets,
	and sets their properties to the values specified in the
	Property Editor.
*******************************************************************************/

Widget AddDemo_shell;

static Widget	_Uxbuild_AddDemo()
{

   Widget form, commandform, altcommform, form2;
   Widget label, sep, sep2;
   int n;
   Arg wargs[10];

	AddDemo_shell = XtVaCreatePopupShell( "AddDemo_shell",
			topLevelShellWidgetClass, DBtoplevel,
			XmNx, 425,
			XmNy, 187,
			XmNtitle, "Demo",
			XmNiconName, "AddDemo",
			NULL );

   n = 0;
   XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_FORM); n++;
   XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_FORM); n++;
   XtSetArg(wargs[n], XmNresizePolicy, XmRESIZE_NONE); n++; 
   XtSetArg (wargs[n], XmNverticalSpacing, 10); n++;
   XtSetArg (wargs[n], XmNhorizontalSpacing, 10); n++;
   AddDemo = XtCreateManagedWidget( "AddDemo", xmFormWidgetClass,
	AddDemo_shell, wargs, n);

	UxPutContext( AddDemo, (char *) UxAddDemoContext );

   n = 0;
   XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_FORM); n++;
   XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_FORM); n++;
   XtSetArg(wargs[n], XmNrightAttachment, XmATTACH_FORM); n++;
   form = XtCreateManagedWidget( "AddDemoform", xmFormWidgetClass, 
	AddDemo, wargs, n);

   n = 0;
   XtSetArg(wargs[n], XmNbottomAttachment, XmATTACH_FORM); n++;
   XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_FORM); n++;
   XtSetArg(wargs[n], XmNborderWidth, 0); n++;
   XtSetArg(wargs[n], XmNrecomputeSize, FALSE); n++;
   XtSetArg(wargs[n], XmNalignment, XmALIGNMENT_BEGINNING); n++;
   label = XtCreateManagedWidget( "NameLabel", xmLabelWidgetClass, 
	form, wargs, n);

   n = 0;
   XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_FORM); n++;
   XtSetArg(wargs[n], XmNrightAttachment, XmATTACH_FORM); n++;
   XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_WIDGET); n++;
   XtSetArg(wargs[n], XmNleftWidget, label); n++;
   XtSetArg(wargs[n], XmNbottomAttachment, XmATTACH_OPPOSITE_WIDGET); n++;
   XtSetArg(wargs[n], XmNleftWidget, label); n++;
   XtSetArg(wargs[n], XmNborderWidth, 0); n++;
   XtSetArg(wargs[n], XmNresizeWidth, FALSE); n++;
   XtSetArg(wargs[n], XmNhighlightOnEnter, TRUE); n++;
   NameText = XtCreateManagedWidget( "NameText", xmTextFieldWidgetClass,
	form, wargs, n);

	UxPutContext( NameText, (char *) UxAddDemoContext );

   n = 0;
   XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_WIDGET); n++;
   XtSetArg(wargs[n], XmNtopWidget, form); n++;
   XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_FORM); n++;
   commandform = XtCreateManagedWidget( "AddDemocommform", xmFormWidgetClass, 
	AddDemo, wargs, n);

   n = 0;
   XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_FORM); n++;
   XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_FORM); n++;
   XtSetArg(wargs[n], XmNrightAttachment, XmATTACH_FORM); n++;
   XtSetArg(wargs[n], XmNborderWidth, 0); n++;
   XtSetArg(wargs[n], XmNrecomputeSize, FALSE); n++;
   XtSetArg(wargs[n], XmNalignment, XmALIGNMENT_BEGINNING); n++;
   label = XtCreateManagedWidget( "CommandLabel", xmLabelWidgetClass,
	commandform, wargs, n);

   n = 0;
   XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_WIDGET); n++; 
   XtSetArg(wargs[n], XmNtopWidget, label); n++;
   XtSetArg(wargs[n], XmNrightAttachment, XmATTACH_FORM); n++;
   XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_FORM); n++;
   XtSetArg(wargs[n], XmNresizeWidth, FALSE); n++;
   XtSetArg(wargs[n], XmNhighlightOnEnter, TRUE); n++;
   XtSetArg (wargs[n], XmNeditMode, XmMULTI_LINE_EDIT); n++;
   XtSetArg (wargs[n], XmNrows, 3); n++;
   XtSetArg (wargs[n], XmNwidth, 300); n++;
   CommandText = XmCreateScrolledText(commandform, "CommandText", wargs, n);
   XtManageChild(CommandText);

	UxPutContext( CommandText, (char *) UxAddDemoContext );

   n = 0;
   XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_WIDGET); n++;
   XtSetArg(wargs[n], XmNtopWidget, form); n++;
   XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_WIDGET); n++;
   XtSetArg(wargs[n], XmNleftWidget, commandform); n++;
   XtSetArg(wargs[n], XmNrightAttachment, XmATTACH_FORM); n++;
   altcommform = XtCreateManagedWidget( "AddDemoaltcommform",xmFormWidgetClass,
	AddDemo, wargs, n);

   n = 0;
   XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_FORM); n++;
   XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_FORM); n++;
   XtSetArg(wargs[n], XmNrightAttachment, XmATTACH_FORM); n++;
   XtSetArg(wargs[n], XmNborderWidth, 0); n++;
   XtSetArg(wargs[n], XmNrecomputeSize, FALSE); n++;
   XtSetArg(wargs[n], XmNalignment, XmALIGNMENT_BEGINNING); n++;
   label = XtCreateManagedWidget( "AltCommandLabel", xmLabelWidgetClass,
	altcommform, wargs, n);

   n = 0;
   XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_WIDGET); n++; 
   XtSetArg(wargs[n], XmNtopWidget, label); n++;
   XtSetArg(wargs[n], XmNrightAttachment, XmATTACH_FORM); n++;
   XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_FORM); n++;
   XtSetArg(wargs[n], XmNresizeWidth, FALSE); n++;
   XtSetArg(wargs[n], XmNhighlightOnEnter, TRUE); n++;
   XtSetArg (wargs[n], XmNeditMode, XmMULTI_LINE_EDIT); n++;
   XtSetArg (wargs[n], XmNrows, 3); n++;
   AltCommandText = XmCreateScrolledText(altcommform, "AltCommandText", wargs, n);
   XtManageChild(AltCommandText);

	UxPutContext( AltCommandText, (char *) UxAddDemoContext );

   n = 0;
   XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_WIDGET); n++;
   XtSetArg(wargs[n], XmNtopWidget, commandform); n++;
   XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_FORM); n++;
   XtSetArg(wargs[n], XmNrightAttachment, XmATTACH_FORM); n++;
   form = XtCreateManagedWidget( "AddDemoform", xmFormWidgetClass, 
	AddDemo, wargs, n);

   n = 0;
   XtSetArg(wargs[n], XmNbottomAttachment, XmATTACH_FORM); n++;
   XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_FORM); n++;
   XtSetArg(wargs[n], XmNborderWidth, 0); n++;
   XtSetArg(wargs[n], XmNrecomputeSize, FALSE); n++;
   XtSetArg(wargs[n], XmNalignment, XmALIGNMENT_BEGINNING); n++;
   label = XtCreateManagedWidget( "WSiconLabel", xmLabelWidgetClass,
	form, wargs, n);

	WSiconText = XtVaCreateManagedWidget( "WSiconText",
			xmTextFieldWidgetClass, form,
			XmNresizeWidth, FALSE,
			XmNhighlightOnEnter, TRUE,
	XmNtopAttachment, XmATTACH_FORM, 
	XmNrightAttachment, XmATTACH_FORM,
	XmNleftAttachment, XmATTACH_WIDGET,
	XmNleftWidget, label,
			NULL );

	UxPutContext( WSiconText, (char *) UxAddDemoContext );

   n = 0;
   XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_WIDGET); n++;
   XtSetArg(wargs[n], XmNtopWidget, form); n++;
   XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_FORM); n++;
   XtSetArg(wargs[n], XmNrightAttachment, XmATTACH_FORM); n++;
   form2 = XtCreateManagedWidget( "AddDemoform", xmFormWidgetClass, 
	AddDemo, wargs, n);

   n = 0;
   XtSetArg(wargs[n], XmNbottomAttachment, XmATTACH_FORM); n++;
   XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_FORM); n++;
   XtSetArg(wargs[n], XmNborderWidth, 0); n++;
   XtSetArg(wargs[n], XmNrecomputeSize, FALSE); n++;
   XtSetArg(wargs[n], XmNalignment, XmALIGNMENT_BEGINNING); n++;
   label = XtCreateManagedWidget( "ImageiconLabel", xmLabelWidgetClass,
	form2, wargs, n);

	ImageiconText = XtVaCreateManagedWidget( "ImageiconText",
			xmTextFieldWidgetClass, form2,
			XmNresizeWidth, FALSE,
			XmNhighlightOnEnter, TRUE,
	XmNtopAttachment, XmATTACH_FORM, 
	XmNrightAttachment, XmATTACH_FORM,
	XmNleftAttachment, XmATTACH_WIDGET,
	XmNleftWidget, label,
			NULL );

	UxPutContext( ImageiconText, (char *) UxAddDemoContext );

   n = 0;
   XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_WIDGET); n++;
   XtSetArg(wargs[n], XmNtopWidget, form2); n++;
   XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_FORM); n++;
   XtSetArg(wargs[n], XmNrightAttachment, XmATTACH_FORM); n++;
   form = XtCreateManagedWidget( "AddDemoform", xmFormWidgetClass, 
	AddDemo, wargs, n);
 
   n = 0;
   XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_FORM); n++;
   XtSetArg(wargs[n], XmNbottomAttachment, XmATTACH_FORM); n++;
   XtSetArg(wargs[n], XmNalignment, XmALIGNMENT_BEGINNING); n++;
   XtSetArg(wargs[n], XmNborderWidth, 0); n++;
   label = XtCreateManagedWidget( "HelpFileLabel",xmLabelWidgetClass,
	form, wargs, n);

   n = 0;
   XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_WIDGET); n++;
   XtSetArg(wargs[n], XmNleftWidget, label); n++;
   XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_FORM); n++;
   XtSetArg(wargs[n], XmNrightAttachment, XmATTACH_FORM); n++;
   XtSetArg(wargs[n], XmNhighlightOnEnter, TRUE); n++;
   HelpFileText = XtCreateManagedWidget("HelpFileText", xmTextFieldWidgetClass,
	form, wargs, n);

   n = 0;
   XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_WIDGET); n++;
   XtSetArg(wargs[n], XmNtopWidget, form); n++;
   XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_FORM); n++;
   XtSetArg(wargs[n], XmNrightAttachment, XmATTACH_FORM); n++;
   XtSetArg(wargs[n], XmNshadowThickness, 7); n++;
   sep = XtCreateManagedWidget( "separatorGadget2", xmSeparatorGadgetClass,
	AddDemo, wargs, n);

   n = 0;
   XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_WIDGET); n++;
   XtSetArg(wargs[n], XmNtopWidget, sep); n++;
   XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_FORM); n++;
   form = XtCreateManagedWidget( "AddDemoform", xmFormWidgetClass, 
	AddDemo, wargs, n);

   n = 0;
   XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_FORM); n++;
   XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_FORM); n++;
   XtSetArg(wargs[n], XmNborderWidth, 0); n++;
   XtSetArg(wargs[n], XmNrecomputeSize, FALSE); n++;
   XtSetArg(wargs[n], XmNalignment, XmALIGNMENT_BEGINNING); n++;
   label = XtCreateManagedWidget( "ExistKeywordLabel", xmLabelWidgetClass,
	form, wargs, n);

	scrolledWindow1 = XtVaCreateManagedWidget( "scrolledWindow1",
			xmScrolledWindowWidgetClass, form,
			RES_CONVERT( XmNbackground, "#7777BB" ),
			XmNvisualPolicy, XmVARIABLE,
			XmNscrollingPolicy, XmAPPLICATION_DEFINED,
			XmNscrollBarDisplayPolicy, XmSTATIC,
			XmNshadowThickness, 0,
	XmNtopAttachment, XmATTACH_WIDGET, 
        XmNtopWidget, label,
	XmNleftAttachment, XmATTACH_FORM,
			NULL );

	UxPutContext( scrolledWindow1, (char *) UxAddDemoContext );

	ExistKeywordList = XtVaCreateManagedWidget( "ExistKeywordList",
			xmListWidgetClass, scrolledWindow1,
			XmNhighlightOnEnter, FALSE,
			XmNhighlightThickness, 2,
			RES_CONVERT( XmNhighlightColor, "black" ),
			XmNscrollBarDisplayPolicy, XmAS_NEEDED,
			XmNlistSizePolicy, XmCONSTANT,
			XmNvisibleItemCount, 10,
			XmNselectionPolicy, XmBROWSE_SELECT,
			XmNlistMarginWidth, 0,
			XmNlistMarginHeight, 2,
			XmNitemCount, ExistKeywordCount,
			RES_CONVERT( XmNitems, ExistKeywordString ),
			XmNwidth, 230,
			NULL );

	UxPutContext( ExistKeywordList, (char *) UxAddDemoContext );

   n = 0;
   XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_WIDGET); n++;
   XtSetArg(wargs[n], XmNtopWidget, form); n++;
   XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_FORM); n++;
   XtSetArg(wargs[n], XmNrightAttachment, XmATTACH_FORM); n++;
   XtSetArg(wargs[n], XmNshadowThickness, 7); n++;
   sep2 = XtCreateManagedWidget( "separatorGadget1", xmSeparatorGadgetClass,
	AddDemo, wargs, n);

   n = 0;
   XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_WIDGET); n++;
   XtSetArg(wargs[n], XmNtopWidget, sep); n++;
   XtSetArg(wargs[n], XmNbottomAttachment, XmATTACH_WIDGET); n++;
   XtSetArg(wargs[n], XmNbottomWidget, sep2); n++;
   XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_WIDGET); n++;
   XtSetArg(wargs[n], XmNleftWidget, form); n++;
   XtSetArg(wargs[n], XmNrightAttachment, XmATTACH_FORM); n++;
   form2 = XtCreateManagedWidget( "AddDemoform", xmFormWidgetClass, 
	AddDemo, wargs, n);

   n = 0;
   XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_FORM); n++;
   XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_FORM); n++;
   XtSetArg(wargs[n], XmNborderWidth, 0); n++;
   XtSetArg(wargs[n], XmNrecomputeSize, FALSE); n++;
   XtSetArg(wargs[n], XmNalignment, XmALIGNMENT_BEGINNING); n++;
   label = XtCreateManagedWidget( "NewKeywordLabel", xmLabelWidgetClass,
	form2, wargs, n);

	NewKeywordText = XtVaCreateManagedWidget( "NewKeywordText",
			xmTextFieldWidgetClass, form2,
			XmNresizeWidth, FALSE,
			XmNhighlightOnEnter, TRUE,
	XmNtopAttachment, XmATTACH_WIDGET, 
        XmNtopWidget, label,
	XmNleftAttachment, XmATTACH_FORM,
	XmNrightAttachment, XmATTACH_FORM,
			NULL );

	UxPutContext( NewKeywordText, (char *) UxAddDemoContext );

   n = 0;
   XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_WIDGET); n++;
   XtSetArg(wargs[n], XmNtopWidget, NewKeywordText); n++;
   XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_FORM); n++;
   XtSetArg(wargs[n], XmNborderWidth, 0); n++;
   XtSetArg(wargs[n], XmNalignment, XmALIGNMENT_BEGINNING); n++;
   label = XtCreateManagedWidget( "DemoKeywordLabel", xmLabelWidgetClass,
	form2, wargs, n);

	DeleteKeywordButton = XtVaCreateManagedWidget( "DeleteKeywordButton",
			xmPushButtonWidgetClass, form2,
			RES_CONVERT( XmNarmColor, "#9f9f9f" ),
			XmNrecomputeSize, FALSE,
			XmNalignment, XmALIGNMENT_CENTER,
			XmNhighlightOnEnter, TRUE,
	XmNbottomAttachment, XmATTACH_FORM,
	XmNrightAttachment, XmATTACH_FORM,
			NULL );

	UxPutContext( DeleteKeywordButton, (char *) UxAddDemoContext );

	scrolledWindow2 = XtVaCreateManagedWidget( "scrolledWindow2",
			xmScrolledWindowWidgetClass, form2,
			RES_CONVERT( XmNbackground, "#7777BB" ),
			XmNvisualPolicy, XmVARIABLE,
			XmNscrollingPolicy, XmAPPLICATION_DEFINED,
			XmNscrollBarDisplayPolicy, XmSTATIC,
			XmNshadowThickness, 0,
	XmNtopAttachment, XmATTACH_WIDGET, 
        XmNtopWidget, label,
	XmNleftAttachment, XmATTACH_FORM,
	XmNrightAttachment, XmATTACH_FORM,
	XmNbottomAttachment, XmATTACH_WIDGET, 
        XmNbottomWidget, DeleteKeywordButton,
			NULL );

	UxPutContext( scrolledWindow2, (char *) UxAddDemoContext );

	DemoKeywordList = XtVaCreateManagedWidget( "DemoKeywordList",
			xmListWidgetClass, scrolledWindow2,
			XmNhighlightOnEnter, FALSE,
			XmNhighlightThickness, 2,
			RES_CONVERT( XmNhighlightColor, "black" ),
			XmNscrollBarDisplayPolicy, XmAS_NEEDED,
			XmNlistSizePolicy, XmCONSTANT,
			XmNselectionPolicy, XmEXTENDED_SELECT,
			XmNlistMarginWidth, 0,
			XmNlistMarginHeight, 2,
			XmNtraversalOn, FALSE,
			NULL );

	UxPutContext( DemoKeywordList, (char *) UxAddDemoContext );

   n = 0;
   XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_WIDGET); n++;
   XtSetArg(wargs[n], XmNtopWidget, sep2); n++;
   XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_FORM); n++;
   XtSetArg(wargs[n], XmNrightAttachment, XmATTACH_FORM); n++;
   form = XtCreateManagedWidget( "AddDemoform", xmFormWidgetClass, 
	AddDemo, wargs, n);

   n = 0;
   XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_FORM); n++;
   XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_FORM); n++;
   XtSetArg(wargs[n], XmNborderWidth, 0); n++;
   XtSetArg(wargs[n], XmNalignment, XmALIGNMENT_BEGINNING); n++;
   label = XtCreateManagedWidget( "ExeFileLabel", xmLabelWidgetClass,
	form, wargs, n);

   n = 0;
   XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_WIDGET); n++;
   XtSetArg(wargs[n], XmNtopWidget, label); n++;
   XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_FORM); n++;
   form2 = XtCreateManagedWidget( "AddDemoform", xmFormWidgetClass, 
	form, wargs, n);

	ExeFileText = XtVaCreateManagedWidget( "ExeFileText",
			xmTextFieldWidgetClass, form2,
			XmNresizeWidth, FALSE,
			XmNcolumns, 55,
			XmNhighlightOnEnter, TRUE,
	XmNtopAttachment, XmATTACH_FORM, 
	XmNleftAttachment, XmATTACH_FORM,
			NULL );

	UxPutContext( ExeFileText, (char *) UxAddDemoContext );

	scrolledWindow3 = XtVaCreateManagedWidget( "scrolledWindow3",
			xmScrolledWindowWidgetClass, form2,
			RES_CONVERT( XmNbackground, "#7777BB" ),
			XmNvisualPolicy, XmVARIABLE,
			XmNscrollingPolicy, XmAPPLICATION_DEFINED,
			XmNscrollBarDisplayPolicy, XmSTATIC,
			XmNshadowThickness, 0,
	XmNtopAttachment, XmATTACH_WIDGET, 
        XmNtopWidget, ExeFileText,
	XmNleftAttachment, XmATTACH_FORM,
	XmNrightAttachment, XmATTACH_FORM,
			NULL );

	UxPutContext( scrolledWindow3, (char *) UxAddDemoContext );

	ExeFileList = XtVaCreateManagedWidget( "ExeFileList",
			xmListWidgetClass, scrolledWindow3,
			XmNhighlightOnEnter, FALSE,
			XmNhighlightThickness, 2,
			RES_CONVERT( XmNhighlightColor, "black" ),
			XmNscrollBarDisplayPolicy, XmAS_NEEDED,
			XmNlistSizePolicy, XmCONSTANT,
			XmNvisibleItemCount, 4,
			XmNselectionPolicy, XmEXTENDED_SELECT,
			XmNlistMarginWidth, 0,
			XmNlistMarginHeight, 2,
			XmNtraversalOn, FALSE,
			NULL );

	UxPutContext( ExeFileList, (char *) UxAddDemoContext );

	DeleteFileButton = XtVaCreateManagedWidget( "DeleteFileButton",
			xmPushButtonWidgetClass, form,
			RES_CONVERT( XmNarmColor, "#9f9f9f" ),
			XmNrecomputeSize, FALSE,
			XmNalignment, XmALIGNMENT_CENTER,
			XmNhighlightOnEnter, TRUE,
	XmNbottomAttachment, XmATTACH_FORM, 
	XmNrightAttachment, XmATTACH_FORM, 
	XmNleftAttachment, XmATTACH_WIDGET,
        XmNleftWidget, form2,
			NULL );

	UxPutContext( DeleteFileButton, (char *) UxAddDemoContext );

	EditButton = XtVaCreateManagedWidget( "EditButton",
			xmPushButtonWidgetClass, form,
			RES_CONVERT( XmNarmColor, "#9f9f9f" ),
			XmNrecomputeSize, FALSE,
			XmNalignment, XmALIGNMENT_CENTER,
			XmNhighlightOnEnter, TRUE,
	XmNbottomAttachment, XmATTACH_WIDGET, 
        XmNbottomWidget, DeleteFileButton,
	XmNrightAttachment, XmATTACH_FORM, 
	XmNleftAttachment, XmATTACH_WIDGET,
        XmNleftWidget, form2,
			NULL );

	UxPutContext( EditButton, (char *) UxAddDemoContext );

   n = 0;
   XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_WIDGET); n++;
   XtSetArg(wargs[n], XmNtopWidget, form); n++;
   XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_FORM); n++;
   XtSetArg(wargs[n], XmNrightAttachment, XmATTACH_FORM); n++;
   XtSetArg(wargs[n], XmNshadowThickness, 7); n++;
   sep = XtCreateManagedWidget( "separatorGadget3", xmSeparatorGadgetClass,
	AddDemo, wargs, n);

   n = 0;
   XtSetArg(wargs[n], XmNtopAttachment, XmATTACH_WIDGET); n++;
   XtSetArg(wargs[n], XmNtopWidget, sep); n++;
   XtSetArg(wargs[n], XmNleftAttachment, XmATTACH_FORM); n++;
   XtSetArg(wargs[n], XmNrightAttachment, XmATTACH_FORM); n++;
   XtSetArg (wargs[n], XmNhorizontalSpacing, 10); n++;
   form = XtCreateManagedWidget( "AddDemoform", xmFormWidgetClass, 
	AddDemo, wargs, n);

	CancelButton = XtVaCreateManagedWidget( "CancelButton",
			xmPushButtonWidgetClass, form,
			RES_CONVERT( XmNarmColor, "#9f9f9f" ),
			XmNrecomputeSize, FALSE,
			XmNalignment, XmALIGNMENT_CENTER,
			XmNhighlightOnEnter, TRUE,
	XmNtopAttachment, XmATTACH_FORM, 
	XmNbottomAttachment, XmATTACH_FORM, 
	XmNrightAttachment, XmATTACH_FORM,
			NULL );

	UxPutContext( CancelButton, (char *) UxAddDemoContext );

	DoneButton = XtVaCreateManagedWidget( "DoneButton",
			xmPushButtonWidgetClass, form,
			RES_CONVERT( XmNarmColor, "#9f9f9f" ),
			XmNrecomputeSize, FALSE,
			XmNalignment, XmALIGNMENT_CENTER,
			XmNhighlightOnEnter, TRUE,
	XmNtopAttachment, XmATTACH_FORM, 
	XmNbottomAttachment, XmATTACH_FORM, 
	XmNrightAttachment, XmATTACH_WIDGET,
	XmNrightWidget, CancelButton,
			NULL );

	UxPutContext( DoneButton, (char *) UxAddDemoContext );

	NextButton = XtVaCreateManagedWidget( "NextButton",
			xmPushButtonWidgetClass, form,
			RES_CONVERT( XmNarmColor, "#9f9f9f" ),
			XmNrecomputeSize, FALSE,
			XmNalignment, XmALIGNMENT_CENTER,
			XmNhighlightOnEnter, TRUE,
	XmNtopAttachment, XmATTACH_FORM, 
	XmNbottomAttachment, XmATTACH_FORM, 
	XmNrightAttachment, XmATTACH_WIDGET,
	XmNrightWidget, DoneButton,
			NULL );

	UxPutContext( NextButton, (char *) UxAddDemoContext );

	XtAddCallback( AddDemo, XmNdestroyCallback,
			UxFreeClientDataCB,
			(XtPointer) UxAddDemoContext );

	XtAddCallback( DoneButton, XmNactivateCallback,
			activateCB_DoneButton,
			(XtPointer) UxAddDemoContext );

	XtAddCallback( CancelButton, XmNactivateCallback,
			activateCB_CancelButton,
			(XtPointer) UxAddDemoContext );

	XtAddCallback( NextButton, XmNactivateCallback,
			activateCB_NextButton,
			(XtPointer) UxAddDemoContext );

	XtAddCallback( ExistKeywordList, XmNbrowseSelectionCallback,
			browseSelectionCB_ExistKeywordList,
			(XtPointer) UxAddDemoContext );

	XtAddCallback( NewKeywordText, XmNactivateCallback,
			activateCB_NewKeywordText,
			(XtPointer) UxAddDemoContext );

	XtAddCallback( ExeFileText, XmNactivateCallback,
			activateCB_ExeFileText,
			(XtPointer) UxAddDemoContext );

	XtAddCallback( DeleteFileButton, XmNactivateCallback,
			activateCB_DeleteFileButton,
			(XtPointer) UxAddDemoContext );

	XtAddCallback( DeleteKeywordButton, XmNactivateCallback,
			activateCB_DeleteKeywordButton,
			(XtPointer) UxAddDemoContext );

	XtAddCallback( EditButton, XmNactivateCallback,
			activateCB_EditButton,
			(XtPointer) UxAddDemoContext );


	return ( AddDemo );
}

/*******************************************************************************
	The following function includes the code that was entered
	in the 'Initial Code' and 'Final Code' sections of the
	Declarations Editor. This function is called from the
	'Interface function' below.
*******************************************************************************/

static Widget	_Ux_create_AddDemo()
{
	Widget                 rtrn;
	_UxCAddDemo             *UxContext;

	UxAddDemoContext = UxContext =
		(_UxCAddDemo *) XtMalloc( sizeof(_UxCAddDemo) );

	rtrn = _Uxbuild_AddDemo();

	XtRealizeWidget( AddDemo_shell );

	SetWMhints ( AddDemo_shell );

	return(rtrn);
}

/*******************************************************************************
	The following is the 'Interface function' which is the
	external entry point for creating this interface.
	This function should be called from your application or from
	a callback function.
*******************************************************************************/

Widget	create_AddDemo()
{
	Widget			_Uxrtrn;

	_Uxrtrn = _Ux_create_AddDemo();

	return ( _Uxrtrn );
}

popup_AddDemo()
{
	struct icntmpltstruct *iconptr;
	char title_string[20];

	if (EditDemoFlag == 1)
	  strcpy (title_string, "EditingDemo");
	else
	  strcpy (title_string, "AddDemo");
	XtVaSetValues( AddDemo_shell,
			XmNtitle, title_string,
			NULL );

	XtVaSetValues( ExistKeywordList,
			XmNitemCount, ExistKeywordCount,
			RES_CONVERT( XmNitems, ExistKeywordString ),
			NULL );

	if (EditDemoFlag == 1) {
	  iconptr = seliconptr->iconptr;
	  XtVaSetValues( NameText, XmNvalue, iconptr->nameptr->string, NULL);
	  XtVaSetValues( NameText, XmNcursorPosition, strlen(iconptr->nameptr->string), NULL );
	  XtVaSetValues( CommandText, XmNvalue, iconptr->startstring, NULL);
	  XtVaSetValues( CommandText, XmNcursorPosition, strlen(iconptr->startstring), NULL );
          if (iconptr->alt_command != NULL)
             {
	  XtVaSetValues( AltCommandText, XmNvalue, iconptr->alt_command, NULL);
	  XtVaSetValues( AltCommandText, XmNcursorPosition, strlen(iconptr->alt_command), NULL );
             }
          if (iconptr->helpfile != NULL)
             {
	  XtVaSetValues(HelpFileText, XmNvalue, iconptr->helpfile->name, NULL);
	  XtVaSetValues(HelpFileText, XmNcursorPosition, strlen(iconptr->helpfile->name), NULL );
             }
	  if (iconptr->geofile != NULL) {
	    XtVaSetValues( WSiconText, XmNvalue, iconptr->geofile->name, NULL);
	    XtVaSetValues( WSiconText, XmNcursorPosition, strlen(iconptr->geofile->name), NULL );
	  }
	  if (iconptr->imgfile != NULL) {
	    XtVaSetValues( ImageiconText, XmNvalue, iconptr->imgfile->name, NULL);
	    XtVaSetValues( ImageiconText, XmNcursorPosition, strlen(iconptr->imgfile->name), NULL );
	  }
	  if (DemoKeywordCount > 0)
	    XtVaSetValues( DemoKeywordList,
			XmNitemCount, DemoKeywordCount,
			RES_CONVERT( XmNitems, DemoKeywordString ),
			NULL );

	  if (ExeFileCount > 0)
	    XtVaSetValues( ExeFileList,
			XmNitemCount, ExeFileCount,
			RES_CONVERT( XmNitems, ExeFileString ),
			NULL );

	  XtUnmapWidget(NextButton);
	}
	else
	  XtMapWidget(NextButton);

      UxPopupInterface(AddDemo, no_grab);
}


GetDemoKeywords()
{
int keyword_count;
XmString *keyword_table;
char *keyword_string;
Arg args[5];
int i, n;
struct charlist *newcharptr;

	if (KW_change) {		/* if there's new keywords */
	  n = 0;
	  XtSetArg(args[n], XmNitemCount, &keyword_count); n++; /* how many items in list */
	  XtSetArg(args[n], XmNitems, &keyword_table); n++; /* the list itself */
	  XtGetValues(DemoKeywordList, args, n);	/* fetch the values */
/*	  printf("Num Demo Keywords = %d\n", keyword_count); */
	  HeadChar = NULL;		/* set head and tail to null */
	  TailChar = NULL;
	  if (keyword_count > 0) {	/* only do if there ARE keywords */
/*	    printf("Demo Keywords = \n"); */
	    for (i=0; i<keyword_count; i++) {	/* traverse list */
	      keyword_string = extract_first_xms_segment(keyword_table[i]);
/*	      printf("%d  %s\n", keyword_count, keyword_string); */
	      newcharptr = (struct charlist *)malloc(sizeof(struct charlist) );
	      if (HeadChar == NULL)
	        HeadChar = newcharptr;	/* if no keywords, set both to null */
	      else
	        TailChar->next = newcharptr; /* set tailchar.next */
              newcharptr->next = NULL;	/* set newcharptr.next to null */
	      TailChar = newcharptr;	/* and set the tail to the keyword */
	      if (find_keyword(keyword_string) != NULL) {
/*	        printf("keyword already exists\n"); */
	        TailChar->indexflag = 1; /* marks it as old */
		TailChar->str = keyword_string; /* put string in list */
	      }
	      else {			/* if keyword doesn't exist */
	        TailChar->indexflag = 0;/* marks it as new */
	        TailChar->str = (char *)malloc(strlen(keyword_string)+1);
	        strcpy(TailChar->str, keyword_string); /* put it in list */
	      }
/*	      printf("%s\n", TailChar->str); */
	    }
	  }
	}
}

/*******************************************************************************
	END OF FILE
*******************************************************************************/

