/*
 * Copyright 1993, 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
/*****************************************************************************/
/***                                                                       ***/
/***             Copyright (c) 1991, Visual Edge Software Ltd.             ***/
/***                                                                       ***/
/***   ALL RIGHTS RESERVED.  This notice is  intended  as  a  precaution   ***/
/***   against  inadvertent publication, and shall not be deemed to con-   ***/
/***   stitute an acknowledgment that publication has  occurred  nor  to   ***/
/***   imply  any  waiver  of confidentiality.  The year included in the   ***/
/***   notice is the year of the creation of the work.                     ***/
/***                                                                       ***/
/*****************************************************************************/
/*				UxXt.h				             */
/*****************************************************************************/

#ifndef	_UX_XT_H_
#define	_UX_XT_H_

/* The following macros are used in converting string values to the form
   required by the widgets */

#define	RES_CONVERT( res_name, res_value) \
	XtVaTypedArg, (res_name), XmRString, (res_value), strlen(res_value) + 1

#define	UxPutStrRes( wgt, res_name, res_value ) \
	XtVaSetValues( wgt, RES_CONVERT( res_name, res_value ), NULL )


#ifndef UX_INTERPRETER	/* Omit this section when interpreting the code */

/* The following macros are supplied for compatibility with swidget code */
#define	swidget			Widget
#define	UxWidgetToSwidget(w)	(w)
#define	UxGetWidget(sw)		(sw)
#define	UxIsValidSwidget(sw)	((sw) != NULL)

#define	no_grab			XtGrabNone
#define	nonexclusive_grab	XtGrabNonexclusive
#define	exclusive_grab		XtGrabExclusive


/* The following global variables are defined in the main() function */
extern XtAppContext DBapp_context;
extern Widget DBtoplevel;

extern  XtAppContext	UxAppContext;
extern  Widget		UxTopLevel;
extern  Display		*UxDisplay;
extern  int		UxScreen;


/* The following are error codes returned by the functions in UxXt.c */
#define UX_ERROR           -1
#define UX_NO_ERROR        0

Boolean UxNotifyFlag;
extern  void	UxWaitForNotify();
extern  void	UxNotify();

/* The following are declarations of the functions in UxXt.c */

#ifdef _NO_PROTO

extern  int	UxPopupInterface();
extern  int	UxPopdownInterface();
extern  int	UxDestroyInterface();
extern  int	UxPutContext();
extern  caddr_t	UxGetContext();
extern  void	UxFreeClientDataCB();
extern  void	UxLoadResources();
extern  int	UxFileExists();


#else

extern  int	UxPopupInterface( Widget wgt, XtGrabKind grab_flag );
extern  int	UxPopdownInterface( Widget wgt );
extern  int	UxDestroyInterface( Widget wgt);
extern  int	UxPutContext( Widget wgt, caddr_t context );
extern  caddr_t	UxGetContext( Widget wgt );
extern  void	UxFreeClientDataCB( Widget wgt, XtPointer client_data,
				 XtPointer call_data );
extern  void	UxLoadResources( char *fname );
extern  int	UxFileExists( char *fname );

#endif /* _NO_PROTO */

#endif /* ! UX_INTERPRETER */

#endif /* ! _UX_XT_H_ */

