/*
 * Copyright 1993, 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */

/*******************************************************************************
	Working.c

*******************************************************************************/

#include <stdio.h>
#include <Xm/Xm.h>
#include <Xm/DialogS.h>
#include <Xm/MenuShell.h>
#include "UxXt.h"

#include <Xm/MessageB.h>

/*******************************************************************************
	Includes, Defines, and Global variables from the Declarations Editor:
*******************************************************************************/

#include "exinterfmotif.h"
#include "exglobals.h"

/*******************************************************************************
	The definition of the context structure:
	If you create multiple instances of your interface, the context
	structure ensures that your callbacks use the variables for the
	correct instance.

	For each Widget in the interface, each argument to the Interface
	function, and each variable in the Instance Specific section of the
	Declarations Editor, there is an entry in the context structure.
	and a #define.  The #define makes the variable name refer to the
	corresponding entry in the context structure.
*******************************************************************************/

typedef	struct
{
	int	mumble;
} _UxCWorking;


static _UxCWorking	*UxWorkingContext;

Widget	Working;

/*******************************************************************************
	Forward declarations of functions that are defined later in this file.
*******************************************************************************/

Widget	create_Working();

/*******************************************************************************
	The following are callback functions.
*******************************************************************************/

static Widget	_Uxbuild_Working()
{
	Widget	Working_shell;

	Working_shell = XtVaCreatePopupShell( "Working_shell",
			xmDialogShellWidgetClass, DBtoplevel,
			XmNx, 650,
			XmNy, 670,
			XmNwidth, 520,
			XmNheight, 380,
			XmNshellUnitType, XmPIXELS,
			XmNtitle, "Working",
			NULL );

	Working = XtVaCreateWidget( "Working",
			xmMessageBoxWidgetClass, Working_shell,
			RES_CONVERT( XmNtextFontList, "-Adobe-Courier-Bold-R-Normal--14-100-100-100-M-90-ISO8859-1" ),
			XmNshadowThickness, 5,
			RES_CONVERT( XmNmessageString, msgstring ),
			XmNmarginHeight, 12,
			XmNmarginWidth, 60,
			RES_CONVERT( XmNlabelFontList, "-Adobe-Helvetica-Bold-R-Normal--14-100-100-100-P-82-ISO8859-1" ),
			RES_CONVERT( XmNforeground, "black" ),
			RES_CONVERT( XmNdialogTitle, "Working" ),
			RES_CONVERT( XmNbuttonFontList, "-Adobe-Helvetica-Bold-R-Normal--14-100-100-100-P-82-ISO8859-1" ),
			RES_CONVERT( XmNbackground, "#BBBBBB" ),
			XmNheight, 380,
			XmNwidth, 520,
			XmNunitType, XmPIXELS,
			NULL );

	UxPutContext( Working, (char *) UxWorkingContext );

	XtAddCallback( Working, XmNdestroyCallback,
			UxFreeClientDataCB,
			(XtPointer) UxWorkingContext );

	XtRealizeWidget ( Working_shell );

	SetWMhints( Working_shell );


	return ( Working );
}

/*******************************************************************************
	The following function includes the code that was entered
	in the 'Initial Code' and 'Final Code' sections of the
	Declarations Editor. This function is called from the
	'Interface function' below.
*******************************************************************************/

static Widget	_Ux_create_Working()
{
	Widget                 rtrn;
	Arg args[10];
	int n;
	_UxCWorking *UxContext;

	UxWorkingContext = UxContext =
		(_UxCWorking *) XtMalloc( sizeof(_UxCWorking) );

	rtrn = _Uxbuild_Working();

	XtUnmanageChild(XmMessageBoxGetChild
	  (Working, XmDIALOG_CANCEL_BUTTON));
	XtUnmanageChild(XmMessageBoxGetChild
	  (Working, XmDIALOG_HELP_BUTTON));
	XtUnmanageChild(XmMessageBoxGetChild
	  (Working, XmDIALOG_OK_BUTTON));

	return(rtrn);
}

/*******************************************************************************
	The following is the 'Interface function' which is the
	external entry point for creating this interface.
	This function should be called from your application or from
	a callback function.
*******************************************************************************/

Widget	create_Working()
{
	Widget			_Uxrtrn;

	_Uxrtrn = _Ux_create_Working();

	return ( _Uxrtrn );
}

/*******************************************************************************
	END OF FILE
*******************************************************************************/

