/*
 * Copyright 1993, 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
#ifndef MENU_H
#define MENU_H

#define MENUBLANK 0
#define MENUWHITE 1
#define MENUGREY 2
#define MENUBLACK 3
#define PDHEIGHT 27
   /* these are regions in the regionlist */
#define DRAWRegion 0
#define PDRegion 1
#define GRPRegion 2
#define ADRegion 3
#define IDXRegion 4
#define SARegion 5
#define RDRegion 6
#define ReRegion 7
#define CBRegion 8
#define Z1Region 9
#define Z2Region 10
   /* these are regions in the MSrgnlist */
#define MSCONTRegion 0
   /* these are regions in the INDXrgnlist */
#define IDNRegion 0
#define ICNCLRegion 1
   /* these are regions in the ADrgnlist */
#define ADNRegion 1
#define ADCRegion 2
#define ADKRegion 3
#define ADDLTRegion 4
#define ADDNRegion 5
#define ADCNCLRegion 6
#define ADNXTRegion 7
#define ADWSIFRegion 8
#define ADIMIFRegion 9
#define ADGRegion 10
#define ADFRegion 11
#define ADFLRegion 12
#define ADDLT2Region 13
   /* these are the regions for the save as window SArgnlist */
#define SATRegion 0
#define SACNCLRegion 1
#define SADNRegion 2
   /* these are the regions for the read window RDrgnlist */
#define RDTRegion 0
#define RDCNCLRegion 1
#define RDDNRegion 2
   /* these are regions in the AGrgnlist */
#define AGNRegion 0
#define AGKRegion 1
#define AGDLTRegion 2
#define AGDNRegion 3
#define AGCNCLRegion 4
#define AGNXTRegion 5
   /* these are the regions for the rearrange window Rergnlist*/
#define ReCNCLRegion 0
#define ReDNRegion 1

#define REGIONCOUNT 15
#define PDCOUNT 5
#define PDENTWIDTH 70
#define PDENTHEIGHT 20

   typedef struct {
   long		xmin, xmax, ymin, ymax;
   } Regiondesc;

Regiondesc regionlist[REGIONCOUNT];
Regiondesc ADrgnlist[REGIONCOUNT];
Regiondesc AGrgnlist[REGIONCOUNT];
Regiondesc SArgnlist[REGIONCOUNT];
Regiondesc RDrgnlist[REGIONCOUNT];
Regiondesc AGrgnlist[REGIONCOUNT];
Regiondesc INDXrgnlist[REGIONCOUNT];
Regiondesc Rergnlist[REGIONCOUNT];
Regiondesc MSrgnlist[REGIONCOUNT];

#endif
