/*
 * Copyright 1993, 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
/*
 * Michelle Boyd
 * December 3, 1991
 *
 * Stroke font derived from 
 *  -sgi-screen-medium-r-normal--18-180-72-72-m-90--ascii
 * 
 * Like kurtfont, each character is a sequence of triplets.  The triplets are:
 *
 *	0,0,0	end of list
 *	1,x,y	translate to x,y
 *	2,x,y	first vertex of connected line is x,y
 *	3,x,y	next vertex of connected line is x,y
 *	4,x,y	last vertex of connected line is x,y
 *
     don't know if the matrix is still this size
 * Characters are defined on a 6x9 matrix (x by y) with Z of zero.
 * Bartfont.h was designed for relative moves and draws.  This file
 * has only absolute coordinates, and is therefore supported with
 * the GL commands translate(), bgnline(), v2i(), and endline().
 */

#define _strokemax 032
long strokemax = _strokemax;

long chrtbl[0200][_strokemax][3] = {
/* c0   */ {{0}},
/* c1   */ {{2,0,4}, {3,2,2}, {4,4,4},
            {2,2,8}, {4,2,2},
            {1,6,0}},
/* c2   */ {{2,0,3}, {3,0,5}, {3,1,6}, {3,2,6}, {3,3,5}, {4,4,6},
            {2,3,5}, {3,3,3}, {4,4,2},
            {2,3,3}, {3,2,2}, {3,1,2}, {4,0,3},
            {1,6,0}},
/* c3   */ {{2,0,0}, {3,1,1}, {3,1,5}, {3,2,6}, {3,4,6}, {3,5,5}, {3,4,4}, {4,1,4},
            {2,4,4}, {3,5,3}, {3,4,2}, {4,1,2},
            {1,7,0}},
/* c4   */ {{2,0,4}, {3,2,6}, {4,4,4},
            {1,6,0}},
/* c5   */ {{2,0,5}, {3,4,5}, {4,4,4},
            {1,6,0}},
/* c6   */ {{2,1,4}, {4,3,4},
            {2,3,6}, {3,2,6}, {3,1,5}, {3,1,3}, {3,2,2}, {4,3,2},
            {1,6,0}},
/* c7   */ {{2,1,2}, {4,1,6},
            {2,0,6}, {4,4,6},
            {2,3,6}, {4,3,2},
            {1,6,0}},
/* c8   */ {{2,0,2}, {4,2,4},
            {2,0,7}, {3,0,6}, {4,4,2},
            {1,6,0}},
/* c9   */ {{0}},
/* c10  */ {{1,0,-9}},
/* c11  */ {{2,0,2}, {3,1,1}, {3,2,2}, {3,2,7}, {3,3,8}, {4,4,7},
            {1,6,0}},
/* c12  */ {{2,0,3}, {4,4,3},
            {2,4,6}, {4,0,6},
            {2,2,8}, {4,2,4},
            {1,6,0}},
/* c13  */ {{0}},
/* c14  */ {{2,1,3}, {3,2,4}, {3,2,5}, {3,3,6}, {3,4,5}, {3,4,4}, {3,3,3}, {4,2,4},
            {2,2,5}, {3,1,6}, {3,0,5}, {3,0,4}, {4,1,3},
            {1,6,0}},
/* c15  */ {{2,0,3}, {3,0,4}, {3,1,5}, {3,3,5}, {3,4,4}, {3,4,6}, {3,2,8}, {4,1,8},
            {2,4,4}, {3,4,3}, {3,3,2}, {3,1,2}, {4,0,3},
            {1,6,0}},
/* c16  */ {{2,4,7}, {3,1,7}, {3,0,6}, {3,0,4}, {3,1,3}, {4,4,3},
            {1,6,0}},
/* c17  */ {{2,0,3}, {3,3,3}, {3,4,4}, {3,4,6}, {3,3,7}, {4,0,7},
            {1,6,0}},
/* c18  */ {{2,0,4}, {3,0,6}, {3,1,7}, {3,3,7}, {3,4,6}, {4,4,4},
            {1,6,0}},
/* c19  */ {{2,0,7}, {3,0,5}, {3,1,4}, {3,3,4}, {3,4,5}, {4,4,7},
            {1,6,0}},
/* c20  */ {{2,0,8}, {3,2,2}, {4,4,8},
            {2,3,6}, {4,1,6},
            {1,6,0}},
/* c21  */ {{2,0,2}, {3,4,2}, {3,4,5}, {4,1,5},
            {2,0,8}, {3,4,8}, {4,4,5},
            {1,6,0}},
/* c22  */ {{2,0,4}, {3,0,6}, {3,1,7}, {3,3,7}, {3,4,6}, {3,4,4}, {3,3,3}, {3,1,3}, {4,0,4},
            {2,1,4}, {4,3,6},
            {2,1,6}, {4,3,4},
            {1,6,0}},
/* c23  */ {{2,2,0}, {3,0,2}, {3,4,6}, {4,2,8},
            {2,0,6}, {4,4,6},
            {2,0,2}, {4,4,2},
            {1,6,0}},
/* c24  */ {{2,0,0}, {4,4,0},
            {1,6,0}},
/* c25  */ {{2,2,3}, {3,4,5}, {4,2,7},
            {2,0,5}, {4,4,5},
            {1,6,0}},
/* c26  */ {{2,0,8}, {3,1,9}, {3,2,9}, {3,2,8}, {3,3,8}, {4,4,9},
            {1,6,0}},
/* c27  */ {{2,0,1}, {4,4,7},
            {2,4,5}, {4,0,5},
            {2,0,3}, {4,4,3},
            {1,6,1}},
/* c28  */ {{2,1,2}, {4,3,2},
            {2,3,4}, {3,1,6}, {4,3,8},
            {1,6,0}},
/* c29  */ {{2,1,2}, {4,3,2},
            {2,1,4}, {3,3,6}, {4,1,8},
            {1,6,0}},
/* c30  */ {{2,0,3}, {4,4,3},
            {2,4,5}, {4,0,5},
            {2,0,7}, {4,4,7},
            {1,6,0}},
/* c31  */ {{2,0,6}, {3,2,4}, {4,4,6},
            {1,6,0}},
/* c32  */ {{1,6,0}},
/* c33 !*/ {{2,3,0}, {4,3,1},
{2,3,3}, {4,3,10},
            {1,6,0}},
/* c34 "*/ {{2,2,10}, {4,2,7},
{2,5,10}, {4,5,7},
            {1,6,0}},
/* c35 #*/ {{2,1,0}, {4,3,10},
            {2,4,0}, {4,6,10},
            {2,0,3}, {4,6,3},
            {2,1,7}, {4,7,7},
            {1,8,0}},
/* c36 $*/ {{2,0,3}, {3,0,2}, {3,2,0}, {3,4,0}, {3,6,2}, {3,6,3},
            {3,4,5}, {3,2,5}, {3,0,7}, {3,0,8}, {3,2,10}, {3,4,10},
            {3,6,8}, {3,6,7}, {4,6,7},
            {2,3,-1}, {4,3,11},
            {1,8,-1}},
/* c37 %*/ {{2,0,0}, {4,6,10},
            {2,1,10}, {3,2,10}, {3,3,9}, {3,3,8}, {3,2,7}, {3,1,7}, {3,0,8}, {3,0,9}, {4,1,10},
            {2,4,0}, {3,5,0}, {3,6,1}, {3,6,2}, {3,5,3}, {3,4,3}, {3,3,2}, {3,3,1}, {4,4,0},
            {1,8,1}},
/* c38 &*/ {{2,6,3}, {3,3,0}, {3,1,0}, {3,0,1}, {3,0,4}, {3,4,8},
            {3,4,9}, {3,3,10}, {3,2,10}, {3,1,9}, {3,1,8}, {4,7,0},
            {1,8,0}},
/* c39 '*/ {{2,3,9}, {3,4,9}, {3,4,10}, {3,3,10}, {3,3,8}, {4,2,7},
            {1,6,1}},
/* c40 (*/ {{2,3,-2}, {3,1,0}, {3,0,3}, {3,0,6}, {3,1,9}, {4,3,11},
            {1,6,0}},
/* c41 )*/ {{2,1,-2}, {3,3,0}, {3,4,3}, {3,4,6}, {3,3,9}, {4,1,11},
            {1,6,0}},
/* c42 **/ {{2,0,3}, {3,2,5}, {3,4,6}, {4,6,8},
            {2,3,2}, {4,3,9},
            {2,0,8}, {3,2,6}, {3,4,5}, {4,6,3},
            {1,8,0}},
/* c43 +*/ {{2,0,5}, {4,6,5},
{2,3,2}, {4,3,8},
            {1,8,0}},
/* c44 ,*/ {{2,5,0}, {3,4,0}, {3,4,1}, {3,5,1}, {3,5,-1}, {4,3,-3},
            {1,8,0}},
/* c45 -*/ {{2,1,5}, {4,6,5},
            {1,8,0}},
/* c46 .*/ {{2,5,0}, {3,4,0}, {3,4,1}, {3,5,1}, {4,5,0},
            {1,8,0}},
/* c47 /*/ {{2,0,0}, {4,5,11},
            {1,8,0}},
/* c48 0*/ {{2,1,2}, {3,3,0}, {3,4,0}, {3,6,2}, {3,6,8}, {3,4,10},
            {3,3,10}, {3,1,8}, {3,1,2}, {4,3,0},
            {2,6,8}, {4,1,3},
            {1,8,0}},
/* c49 1*/ {{2,1,0}, {4,5,0},
            {2,3,0}, {3,3,10}, {4,1,8},
            {1,8,0}},
/* c50 2*/ {{2,1,7}, {3,1,8}, {3,3,10}, {3,4,10}, {3,6,8}, {3,6,6}, {3,1,1}, {3,1,0}, {4,6,0},
            {1,8,0}},
/* c51 3*/ {{2,1,2}, {3,3,0}, {3,4,0}, {3,6,2}, {3,6,3}, {3,4,5}, {4,3,5},
{2,4,5}, {3,6,7}, {3,6,8}, {3,4,10}, {3,3,10}, {4,1,8},
            {1,8,0}},
/* c52 4*/ {{2,5,0}, {3,5,10}, {3,2,7}, {3,1,4}, {4,6,4},
            {1,8,0}},
/* c53 5*/ {{2,1,2}, {3,3,0}, {3,4,0}, {3,6,2}, {3,6,4}, {3,4,6}, {3,1,6}, {3,1,10}, {4,6,10},
            {1,8,0}},
/* c54 6*/ {{2,1,4}, {3,3,6}, {3,4,6}, {3,6,4}, {3,6,2}, {3,4,0}, {3,3,0}, {3,1,2}, {3,1,8}, {3,3,10}, {3,5,10}, {4,6,9},
            {1,8,0}},
/* c55 7*/ {{2,1,10}, {3,6,10}, {3,6,9}, {4,3,0},
            {1,8,0}},
/* c56 8*/ {{2,3,0}, {3,4,0}, {3,6,2}, {3,6,3}, {3,4,5}, {3,3,5}, {3,1,3}, {3,1,2}, {4,3,0},
{2,3,5}, {3,4,5}, {3,6,7}, {3,6,8}, {3,4,10}, {3,3,10}, {3,1,8}, {3,1,7}, {4,3,5},
            {1,8,0}},
/* c57 9*/ {{2,1,1}, {3,2,0}, {3,4,0}, {3,6,2}, {3,6,8}, {3,4,10}, {3,3,10}, {3,1,8}, {3,1,6}, {3,3,4}, {3,4,4}, {4,6,6},
            {1,8,0}},
/* c58 :*/ {{2,5,0}, {3,4,0}, {3,4,1}, {3,5,1}, {4,5,0},
{2,5,5}, {3,4,5}, {3,4,6}, {3,5,6}, {4,5,5},
            {1,8,0}},
/* c59 ;*/ {{2,5,0}, {3,4,0}, {3,4,1}, {3,5,1}, {3,5,-1}, {4,3,-3},
{2,5,5}, {3,4,5}, {3,4,6}, {3,5,6}, {4,5,5},
            {1,8,0}},
/* c60 <*/ {{2,6,0}, {3,1,5}, {4,6,10},
            {1,8,0}},
/* c61 =*/ {{2,1,6}, {4,7,6},
{2,1,3}, {4,7,3},
            {1,8,0}},
/* c62 >*/ {{2,1,0}, {3,6,5}, {4,1,10},
            {1,8,0}},
/* c63 ?*/ {{2,4,0}, {4,4,1},
            {2,4,3}, {3,4,4}, {3,6,6}, {3,6,8}, {3,4,10}, {3,3,10}, {3,1,8}, {4,1,7},

            {1,8,0}},
/* c64 @*/ {{2,5,1}, {3,4,0}, {3,2,0}, {3,0,2}, {3,0,8}, {3,2,10}, {3,3,10}, {3,5,8}, {3,5,4}, {3,4,3}, {3,3,3}, {3,2,4}, {3,2,6}, {3,3,7}, {4,5,7},
            {1,8,0}},
/* c65 A*/ {{2,0,0}, {3,0,3}, {3,6,3}, {4,6,0}, 
            {2,0,3}, {3,3,11}, {4,6,3},
            {1,9,0}},
/* c66 B*/ {{2,0,0}, {3,0,11}, {3,4,11}, {3,6,9}, {3,6,8}, {3,4,6}, {4,0,6},
            {2,0,0}, {3,4,0}, {3,6,2}, {3,6,4}, {4,4,6},
            {1,9,0}},
/* c67 C*/ {{2,6,2}, {3,4,0}, {3,2,0}, {3,0,2}, {3,0,9}, {3,2,11}, {3,4,11}, {4,6,9},
            {1,9,0}},
/* c68 D*/ {{2,0,0}, {3,4,0}, {3,6,2}, {3,6,9}, {3,4,11}, {3,0,11},
            {4,0,0},
            {1,9,0}},
/* c69 E*/ {{2,6,0}, {3,0,0}, {3,0,11}, {4,6,11},
            {2,0,6}, {4,5,6},
            {1,9,0}},
/* c70 F*/ {{2,0,0}, {3,0,11}, {4,6,11},
            {2,0,6}, {4,5,6},
            {1,9,0}},
/* c71 G*/ {{2,4,5}, {3,6,5}, {4,6,0}, {2,6,2}, {3,4,0},
            {3,2,0}, {3,0,2}, {3,0,9}, {3,2,11}, {3,4,11}, {4,6,9},
            {1,9,0}},
/* c72 H*/ {{2,0,0}, {4,0,11},
            {2,0,6}, {4,6,6},
            {2,6,0}, {4,6,11},
            {1,9,0}},
/* c73 I*/ {{2,2,0}, {4,4,0},
            {2,2,11}, {4,4,11},
            {2,3,0}, {4,3,11},
            {1,9,0}},
/* c74 J*/ {{2,0,3}, {3,0,2}, {3,2,0}, {3,3,0}, {3,5,2}, {4,5,11},
            {1,9,0}},
/* c75 K*/ {{2,0,0}, {4,0,11},
            {2,0,5}, {4,6,11},
            {2,1,6}, {3,6,1}, {4,6,0},
            {1,9,0}},
/* c76 L*/ {{2,0,11}, {3,0,0}, {4,6,0},
            {1,9,0}},
/* c77 M*/ {{2,0,0}, {3,0,11}, {3,3,4}, {3,6,11}, {4,6,0},
            {1,9,0}},
/* c78 N*/ {{2,0,0}, {3,0,11}, {3,6,0}, {4,6,11},
            {1,9,0}},
/* c79 O*/ {{2,0,2}, {3,0,9}, {3,2,11}, {3,4,11}, {3,6,9}, {3,6,2}, {3,4,0}, {3,2,0}, {4,0,2},
            {1,9,0}},
/* c80 P*/ {{2,0,0}, {3,0,11}, {3,4,11}, {3,6,9}, {3,6,7}, {3,4,5}, {4,0,5},
            {1,9,0}},
/* c81 Q*/ {{2,0,2}, {3,0,9}, {3,2,11}, {3,4,11}, {3,6,9}, {3,6,2},
            {3,4,0}, {3,2,0}, {4,0,2},
            {2,3,1}, {3,4,-1}, {4,6,-3},
            {1,9,0}},
/* c82 R*/ {{2,0,0}, {3,0,11}, {3,4,11}, {3,6,9}, {3,6,7}, {3,4,5}, {4,0,5},
            {2,2,5}, {3,6,1}, {4,6,0},
            {1,9,0}},
/* c83 S*/ {{2,0,2}, {3,2,0}, {3,4,0}, {3,6,2}, {3,6,4}, {3,4,6}, {3,2,6},
            {3,0,8}, {3,0,9}, {3,2,11}, {3,4,11}, {4,6,9},
            {1,9,0}},
/* c84 T*/ {{2,0,11}, {4,6,11},
            {2,3,0}, {4,3,11},
            {1,9,0}},
/* c85 U*/ {{2,0,11}, {3,0,2}, {3,2,0}, {3,4,0}, {3,6,2}, {4,6,11},
            {1,9,0}},
/* c86 V*/ {{2,0,11}, {3,3,0}, {4,6,11},
            {1,9,0}},
/* c87 W*/ {{2,0,11}, {3,0,4}, {3,1,0}, {3,3,9}, {3,5,0}, {3,6,4}, {4,6,11},
            {1,9,0}},
/* c88 X*/ {{2,0,11}, {3,1,8}, {3,5,3}, {4,6,0}, 
            {2,0,0}, {3,1,3}, {3,5,8}, {4,6,11},
            {1,9,0}},
/* c89 Y*/ {{2,0,11}, {3,3,5}, {4,3,0},
            {2,9,11}, {4,3,5},
            {1,9,0}},
/* c90 Z*/ {{2,0,11}, {3,6,11}, {3,5,8}, {3,1,3}, {3,0,0}, {4,6,0},
            {1,9,0}},
/* c91 [*/ {{2,4,-2}, {3,1,-2}, {3,1,11}, {4,4,11},
            {1,8,0}},
/* c92  */ {{2,0,7}, {4,4,3},
            {1,8,0}},
/* c93 ]*/ {{2,1,-2}, {3,4,-2}, {3,4,11}, {4,1,11},
            {1,8,0}},
/* c94 ^*/ {{2,2,8}, {3,4,10}, {4,6,8},
            {1,8,0}},
/* c95 _*/ {{2,0,-3}, {4,7,-3},
            {1,8,0}},
/* c96 `*/ {{2,4,9}, {3,3,9}, {3,3,10}, {3,4,10}, {3,4,8}, {4,5,7},
            {1,6,0}},
/* c97 a*/ {{2,5,2}, {3,3,0}, {3,1,0}, {3,0,1}, {3,0,3}, {3,2,5}, {4,5,5},
	    {2,6,0}, {3,5,1}, {3,5,7}, {3,4,8}, {3,1,8}, {4,0,7},
            {1,9,0}},
/* c98 b*/ {{2,0,0}, {4,0,11}, {2,0,2}, {3,2.0}, {3,4,0}, {3,6,2}, {3,6,6},
            {3,4,8}, {3,2,8}, {4,0,6},
            {1,9,0}},
/* c99 c*/ {{2,6,2}, {3,4,0}, {3,2,0}, {3,0,2}, {3,0,6}, {3,2,8}, {3,4,8}, {4,6,6},
            {1,9,0}},
/* c100 d*/ {{2,6,2}, {3,4,0}, {3,2,0}, {3,0,2}, {3,0,6}, {3,2,8}, {3,4,8}, {4,6,6},
            {2,6,0}, {4,6,11},
            {1,9,0}},
/* c101 e*/ {{2,6,1}, {3,5,0}, {3,2,0}, {3,0,2}, {3,0,6}, {3,2,8}, {3,4,8},
            {3,6,6}, {3,6,4}, {4,0,4},
            {1,9,0}},
/* c102 f*/ {{2,2,0}, {3,2,10}, {3,3,11}, {4,6,11},
            {2,0,8}, {4,5,8},
            {1,9,0}},
/* c103 g*/ {{2,6,2}, {3,4,0}, {3,2,0}, {3,0,2}, {3,0,6}, {3,2,8}, {3,4,8}, {4,6,6},
            {2,6,8}, {3,6,-3}, {3,4,-5}, {3,1,-5}, {4,0,-4},
            {1,9,0}},
/* c104 h*/ {{2,0,0}, {4,0,11},
            {2,0,6}, {3,2,8}, {3,4,8}, {3,6,6}, {4,6,0},
            {1,9,0}},
/* c105 i*/ {{2,2,8}, {3,4,8}, {4,4,0},
            {2,4,10}, {4,4,11},
            {1,9,0}},
/* c106 j*/ {{2,0,-3}, {3,1,-4}, {3,3,-4}, {3,5,-2}, {3,5,8}, {4,3,8},
            {2,5,10}, {4,5,11},
            {1,9,0}},
/* c107 k*/ {{2,0,0}, {4,0,11},
            {2,0,3}, {4,5,8},
            {2,6,0}, {4,2,4},
            {1,9,0}},
/* c108 l*/ {{2,2,11}, {3,4,11}, {4,4,0},
            {1,9,0}},
/* c109 m*/ {{2,0,0}, {3,0,8}, {3,2,8}, {3,3,7}, {4,3,0},
            {2,3,7}, {3,4,8}, {3,5,8}, {3,6,7}, {4,6,0},
            {1,9,0}},
/* c110 n*/ {{2,0,0}, {4,0,8}, {2,0,6}, {3,2,8}, {3,4,8}, {3,6,6}, {4,6,0},
            {1,9,0}},
/* c111 o*/ {{2,6,2}, {3,4,0}, {3,2,0}, {3,0,2}, {3,0,6}, {3,2,8},
            {3,4,8}, {3,6,6}, {4,6,2},
            {1,9,0}},
/* c112 p*/ {{2,0,-4}, {4,0,8}, 
            {2,0,6}, {3,2,8}, {3,4,8}, {3,6,6}, {3,6,2}, {3,4,0},
            {3,2,0}, {4,0,2},
            {1,9,0}},
/* c113 q*/ {{2,6,2}, {3,4,0}, {3,2,0}, {3,0,2}, {3,0,6}, {3,2,8},
            {3,4,8}, {4,6,6}, {2,6,8}, {4,6,-4},
            {1,9,0}},
/* c114 r*/ {{2,0,0}, {4,0,8},
            {2,0,6}, {3,2,8}, {3,4,8}, {4,5,7},
            {1,9,0}},
/* c115 s*/ {{2,0,1}, {3,1,0}, {3,4,0}, {3,6,2}, {3,6,3}, {3,4,5},
            {3,1,5}, {3,0,6}, {3,0,7}, {3,1,8}, {3,5,8}, {4,6,7},
            {1,9,0}},
/* c116 t*/ {{2,0,8}, {4,4,8},
            {2,2,10}, {3,2,2}, {3,4,0}, {4,5,0},
            {1,9,0}},
/* c117 u*/ {{2,0,8}, {3,0,2}, {3,2,0}, {3,4,0}, {4,6,2},
            {2,6,0}, {4,6,8},
            {1,9,0}},
/* c118 v*/ {{2,0,8}, {3,0,6}, {3,3,0}, {3,6,6}, {4,6,8},
            {1,9,0}},
/* c119 w*/ {{2,0,8}, {3,0,2}, {3,1,0}, {3,3,5}, {3,5,0}, {3,6,2}, {4,6,8},
            {1,9,0}},
/* c120 x*/ {{2,0,0}, {3,0,1}, {3,6,7}, {4,6,8},
            {2,0,8}, {3,0,7}, {3,6,1}, {4,6,0},
            {1,9,0}},
/* c121 y*/ {{2,0,8}, {3,0,2}, {3,2,0}, {3,4,0}, {4,6,2},
            {2,6,8}, {3,6,-3}, {3,4,-5}, {3,1,-5}, {4,0,-4},
            {1,9,0}},
/* c122 z*/ {{2,0,8}, {3,6,8}, {3,6,7}, {3,0,1}, {3,0,0}, {4,6,0},
            {1,9,0}},
/* c123 {*/ {{2,7,-3}, {3,5,-3}, {3,4,-2}, {3,4,3}, {3,3,4}, {3,2,4}, {3,3,4}, {3,4,5}, {3,4,10}, {3,5,11}, {4,7,11},
            {1,8,0}},
/* c124 |*/ {{2,3,-3}, {4,3,11},
            {1,8,0}},
/* c125 }*/ {{2,1,-3}, {3,3,-3}, {3,4,-2}, {3,4,3}, {3,5,4}, {3,6,4}, {3,5,4}, {3,4,5}, {3,4,10}, {3,3,11}, {4,1,11},
            {1,8,0}},
/* c126 ~*/ {{2,1,8}, {3,1,9}, {3,2,10}, {3,5,8}, {3,6,9}, {4,6,10},
            {1,8,0}},
/* c127 */ {{0}},
};	/* End of chrtbl */
